class xoshiro128 {

	constructor(seedval) {
		this.state = [];
		this.seed = seedval;
		this.seedRNG(seedval);
	}

	seedRNG(seedval) {
		this.seed = seedval;
		this.state[0] = seedval;
		for(var l = 0; l < 16; l++) { this.nextRandom(); }
	}

	rotateBits(val, amt) {
		return (val << amt) | (val >>> (32 - amt));
	}

	nextRandom() {
		var rtnval = this.rotateBits(this.state[0] * 5, 7) * 9;
		var tmpval = this.state[1] << 9;

		this.state[2] ^= this.state[0];
		this.state[3] ^= this.state[1];
		this.state[1] ^= this.state[2];
		this.state[0] ^= this.state[3];

		this.state[2] ^= tmpval;

		this.state[3] = this.rotateBits(this.state[3], 11);

		return (rtnval >>> 0);
	}

	// this returns a random number that is a positive float between zero and one
	getRandom() {
		return Math.abs((this.nextRandom() % 1000) / 1000.0);
	}

	// this returns a random integer between 0 (inclusive) and limit (exclusive)
	rnd(limit) {
		return Math.floor(limit * this.getRandom());
	}
}
